#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <time.h>


static void quicksort(int* tab, int low, int high) {
    int l = low;
    int i, j;
    int K;

    while (l < high) {
        if (tab[l] < 0) {
            tab[l] = -tab[l];
            l++;
        }
        else {
            i = j = l;
            K = tab[l];
            inc: j++;
            while (K <= tab[j]) j++;

            if (tab[j] > 0) {
                tab[i] = tab[j];
                i++;
                tab[j] = tab[i];

                goto inc;
            }

            tab[i] = -K;
        }
    }
}

int main() {
    const int N = 500000;
    clock_t t1, t2;
    
    float moy[10];

    for (int j = 0; j < 10; j++) {
        srand(j);
        int a[N];

        for (int i = 0; i < N; i++) {
            do a[i] = rand() % 1000;
            while (a[i] == 0);
        }

        /* Decommenter ce code et commenter la boucle prcdente pour un 
         * tableau dj tri en entre de la fonction */
        /*for (int i = 0; i < N; i++) {
            a[i] = i+1;
        }*/
    
        a[N-1] = -1; // Ncessaire pour cet algorithme !

        t1 = clock();
        quicksort(a, 0, N);
        t2 = clock();
        moy[j] = (float) (t2 - t1)/CLOCKS_PER_SEC;
        printf("%d: It tooks: %f\n", j, moy[j]);
    }

    float moyenne = 0;

    for (int i = 0; i < 10; moyenne += moy[i++]);
    printf("Moyenne: %f\n", moyenne / 10);

    return 0;
}